package mvcsSkeleton.views.mediators
{
	import mvcsSkeleton.controllers.events.BehavioursEvent;
	import mvcsSkeleton.controllers.events.StatisticsEvent;
	import mvcsSkeleton.views.api.IMakeCircles;

	import robotlegs.bender.bundles.mvcs.Mediator;

	public class MakeCirclesMediator extends Mediator
	{
		[Inject]
		public var view:IMakeCircles;

		override public function initialize():void
		{
			addContextListener(BehavioursEvent.MAKE_CIRCLE_REQUESTED, onMakeCircle, BehavioursEvent);

			//LISTEN FOR STATISTICS EVENTS FROM VIEW
			addViewListener(StatisticsEvent.ELEMENT_ADDED, onElementAdded, StatisticsEvent);
			addViewListener(StatisticsEvent.ELEMENT_REMOVED, onElementRemoved, StatisticsEvent);
		}

		private function onElementAdded(event:StatisticsEvent):void
		{
			if (event.payload.shapeName == "circle")
				dispatch(event);
		}

		private function onElementRemoved(event:StatisticsEvent):void
		{
			if (event.payload.shapeName == "circle")
				dispatch(event);
		}

		private function onMakeCircle(event:BehavioursEvent):void
		{
			//view == views implementing IMakeCircles MonomorphicViewTwo,PolymorphicView)
			view.makeCircle(Number(event.payload));
		}
	}
}
