package mvcsSkeleton.views.mediators
{
	import mvcsSkeleton.controllers.events.BehavioursEvent;
	import mvcsSkeleton.controllers.events.StatisticsEvent;
	import mvcsSkeleton.views.api.IMakeSquares;

	import robotlegs.bender.bundles.mvcs.Mediator;

	public class MakeSquaresMediator extends Mediator
	{
		[Inject]
		public var view:IMakeSquares;

		override public function initialize():void
		{
			addContextListener(BehavioursEvent.MAKE_SQUARE_REQUESTED, onMakeSquare, BehavioursEvent);

			//LISTEN FOR STATISTICS EVENT
			addViewListener(StatisticsEvent.ELEMENT_ADDED, onElementAdded, StatisticsEvent);
			addViewListener(StatisticsEvent.ELEMENT_REMOVED, onElementRemoved, StatisticsEvent);
		}

		private function onElementAdded(event:StatisticsEvent):void
		{
			if (event.payload.shapeName == "square")
				dispatch(event);
		}

		private function onElementRemoved(event:StatisticsEvent):void
		{
			if (event.payload.shapeName == "square")
				dispatch(event);
		}

		private function onMakeSquare(event:BehavioursEvent):void
		{
			//view == views implementing IMakeSquares: MonomorphicViewOne,PolymorphicView)
			view.makeSquare(Number(event.payload));
		}
	}
}
